package org.eweb4j.mvc.config.creator;

import org.eweb4j.mvc.config.bean.FieldConfigBean;
import org.eweb4j.mvc.config.bean.ValidatorConfigBean;
import org.eweb4j.mvc.validator.Validators;
import org.eweb4j.mvc.validator.annotation.Zip;
import org.eweb4j.util.CommonUtil;


public class ZipImpl implements ValidatorCreator {

	private Zip ann;

	public ZipImpl(Zip ann) {
		this.ann = ann;
	}

	public ValidatorConfigBean create(String fieldName, ValidatorConfigBean val) {
		if (this.ann == null)
			return null;
		if (val == null || !Validators.ZIP.equals(val.getName())) {
			val = new ValidatorConfigBean();
			val.setName(Validators.ZIP);
		}

		FieldConfigBean fcb = new FieldConfigBean();
		fcb.setName(fieldName);
		fcb.setMessage(CommonUtil.parsePropValue(ann.mess()));

		val.getField().add(fcb);

		return val;
	}

}
